models/Compras.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "compras".
 *
 * @property int $idCompra
 * @property int|null $idEvento
 * @property int|null $idUsuario
 * @property int|null $cantidad
 * @property string|null $fechaCompra
 * @property float|null $precioCompra
 * @property string|null $estado
 * @property float|null $total
 * @property string $fechaModificacion
 */
class Compras extends \yii\db\ActiveRecord
{
    // Define la constante ESTADO_PAGADO
    const ESTADO_PAGADO = 'pagado';

    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'compras';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['idEvento', 'idUsuario', 'cantidad'], 'integer'],
            [['fechaCompra', 'fechaModificacion'], 'safe'],
            [['precioCompra', 'total'], 'number'],
            [['estado'], 'string'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'idCompra' => 'Id Compra',
            'idEvento' => 'Id Evento',
            'idUsuario' => 'Id Usuario',
            'cantidad' => 'Cantidad',
            'fechaCompra' => 'Fecha Compra',
            'precioCompra' => 'Precio Compra',
            'estado' => 'Estado',
            'total' => 'Total',
            'fechaModificacion' => 'Fecha Modificacion',
        ];
    }
}

controllers/ComprasController.php
<?php
namespace app\controllers;

use Yii;
use yii\web\Controller;
use yii\filters\AccessControl;
use app\models\Eventos;
use app\models\Compras;
use Stripe\Stripe;
use Stripe\Charge;
use Mpdf\Mpdf;

class ComprasController extends Controller
{
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['index', 'add', 'update-cart', 'remove', 'checkout', 'confirm', 'compra-confirmada', 'download-pdf', 'checkout-stripe', 'charge'],
                'rules' => [
                    [
                        'actions' => ['index', 'add', 'update-cart', 'remove', 'checkout', 'confirm', 'compra-confirmada', 'download-pdf', 'checkout-stripe', 'charge'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
        ];
    }

    public function actionIndex()
    {
        $cart = Yii::$app->session->get('cart', []);

        // Actualizar precios desde la base de datos
        foreach ($cart as $key => &$item) {
            $event = Eventos::findOne($item['id']);
            if ($event) {
                $item['price'] = $event->precio; // Actualizar el precio
            }
        }
        Yii::$app->session->set('cart', $cart); // Guardar el carrito actualizado

        return $this->render('index', ['cart' => $cart]);
    }

    public function actionAdd()
    {
        $id = Yii::$app->request->post('id');
        $quantity = Yii::$app->request->post('cantidad', 1); // Captura la cantidad, por defecto 1
        if ($id !== null && $quantity !== null) {
            $event = Eventos::findOne($id);
            if ($event) {
                $cart = Yii::$app->session->get('cart', []);
                if (isset($cart[$id])) {
                    $cart[$id]['quantity'] += $quantity; // Suma la cantidad seleccionada
                } else {
                    $cart[$id] = [
                        'id' => $event->idEvento,
                        'name' => $event->nombrEvento,
                        'price' => $event->precio,
                        'quantity' => $quantity, // Establece la cantidad seleccionada
                    ];
                }
                Yii::$app->session->set('cart', $cart);
            }
            return $this->redirect(['compras/index']);
        } else {
            throw new \yii\web\BadRequestHttpException('Parámetros requeridos ausentes: id o cantidad');
        }
    }

    public function actionUpdateCart()
    {
        if (Yii::$app->request->isPost) {
            $id = Yii::$app->request->post('id');
            $quantity = Yii::$app->request->post('quantity');

            if ($id !== null && $quantity > 0) {
                $cart = Yii::$app->session->get('cart', []);
                if (isset($cart[$id])) {
                    $cart[$id]['quantity'] = $quantity;
                    Yii::$app->session->set('cart', $cart);
                }
            }
        }
    }

    public function actionRemove($id)
    {
        $cart = Yii::$app->session->get('cart', []);
        if (isset($cart[$id])) {
            unset($cart[$id]);
            Yii::$app->session->set('cart', $cart);
        }
        return $this->redirect(['compras/index']);
    }

    public function actionCheckout()
    {
        $cart = Yii::$app->session->get('cart', []);
        if (empty($cart)) {
            return $this->redirect(['compras/index']);
        }

        return $this->redirect(['compras/confirm']);
    }

    public function actionConfirm()
    {
        $cart = Yii::$app->session->get('cart', []);
        $purchaseTime = date('Y-m-d H:i:s');
        $userId = Yii::$app->user->id;

        foreach ($cart as $item) {
            $compra = new Compras();
            $compra->idEvento = $item['id'];
            $compra->idUsuario = $userId;
            $compra->cantidad = $item['quantity'];
            $compra->fechaCompra = $purchaseTime;
            $compra->precioCompra = $item['price'];
            $compra->estado = Compras::ESTADO_PAGADO;
            $compra->save();
        }

        Yii::$app->session->remove('cart'); // Limpiar el carrito después de la compra

        return $this->redirect(['compra-confirmada', 'cart' => json_encode($cart), 'purchaseTime' => $purchaseTime]);
    }

    public function actionCompraConfirmada($cart, $purchaseTime)
    {
        $cart = json_decode($cart, true);
        return $this->render('compra-confirmada', [
            'cart' => $cart,
            'purchaseTime' => $purchaseTime
        ]);
    }

    public function actionDownloadPdf($cart, $purchaseTime)
    {
        $cart = json_decode($cart, true);

        // Configurar la fuente personalizada
        $defaultConfig = (new \Mpdf\Config\ConfigVariables())->getDefaults();
        $fontDirs = $defaultConfig['fontDir'];

        $defaultFontConfig = (new \Mpdf\Config\FontVariables())->getDefaults();
        $fontData = $defaultFontConfig['fontdata'];

        $mpdf = new Mpdf([
            'fontDir' => array_merge($fontDirs, [
                Yii::getAlias('@webroot/fonts'),
            ]),
            'fontdata' => $fontData + [
                'permanentmarker' => [
                    'R' => 'PermanentMarker-Regular.ttf',
                ]
            ],
        ]);

        $html = $this->renderPartial('confirm-pdf', ['cart' => $cart, 'purchaseTime' => $purchaseTime]);
        $mpdf->WriteHTML($html);
        $mpdf->Output('comprobante.pdf', 'D'); // Descargar el PDF directamente
    }

    public function actionCancel()
    {
        return $this->render('cancel');
    }

    // Comprar con Stripe
    public function actionCheckoutStripe()
    {
        $cart = Yii::$app->session->get('cart', []);
        if (empty($cart)) {
            return $this->redirect(['compras/index']);
        }

        // Obtener el entorno actual
        $env = Yii::$app->params['stripe.env'];
        $publishableKey = Yii::$app->params['stripe'][$env]['publishableKey'];
        $totalAmount = 0;

        foreach ($cart as $item) {
            $totalAmount += $item['price'] * $item['quantity'];
        }

        return $this->render('checkout-stripe', [
            'cart' => $cart,
            'publishableKey' => $publishableKey,
            'totalAmount' => $totalAmount * 100, // VALOR DE STRIPE EN CENTAVOS
        ]);
    }

    public function actionCharge()
    {
        // Obtener el entorno actual
        $env = Yii::$app->params['stripe.env'];
        \Stripe\Stripe::setApiKey(Yii::$app->params['stripe'][$env]['secretKey']);

        $token = Yii::$app->request->post('stripeToken');
        $totalAmount = Yii::$app->request->post('totalAmount');
        $cart = Yii::$app->session->get('cart', []);
        $purchaseTime = date('Y-m-d H:i:s');
        $userId = Yii::$app->user->id;

        try {
            $charge = \Stripe\Charge::create([
                'amount' => $totalAmount,
                'currency' => 'usd',
                'description' => 'Compra de entradas',
                'source' => $token,
            ]);

            foreach ($cart as $item) {
                $compra = new Compras();
                $compra->idEvento = $item['id'];
                $compra->idUsuario = $userId;
                $compra->cantidad = $item['quantity'];
                $compra->fechaCompra = $purchaseTime;
                $compra->precioCompra = $item['price'];
                $compra->estado = Compras::ESTADO_PAGADO;
                $compra->save();
            }

            Yii::$app->session->remove('cart');

            return $this->redirect(['compra-confirmada', 'cart' => json_encode($cart), 'purchaseTime' => $purchaseTime]);
        } catch (\Exception $e) {
            Yii::$app->session->setFlash('error', 'Error en el pago: ' . $e->getMessage());
            return $this->redirect(['compras/index']);
        }
    }
}

controllers/EventosController.php
<?php
namespace app\controllers;

use app\models\Eventos;
use app\models\Compras;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Yii;
use yii\web\Response;

/**
 * EventosController implements the CRUD actions for Eventos model.
 */
class EventosController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Eventos models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Eventos::find()
                ->where(['>=', 'fecha', date('Y-m-d')]) // Filtrar eventos que no hayan pasado
                ->orderBy(['fecha' => SORT_ASC]), // Ordenar por fecha ascendente
            'pagination' => [
                'pageSize' => 6, // Mostrar solo 6 eventos por página
            ],
        ]);
    
        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }
    
    /**
     * Displays a single Eventos model.
     * @param int $idEvento Id Evento
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($idEvento)
    {
        $model = $this->findModel($idEvento);
        $agente = $model->idAgente0; // Obtener el agente relacionado

        // Obtener los teléfonos del agente
        $telefonosAgente = $agente ? $agente->telefonosagentes : [];

        $compraModel = new Compras(); // Crear una instancia del modelo Compras

        return $this->render('view', [
            'model' => $model,
            'agente' => $agente,
            'telefonosAgente' => $telefonosAgente,
            'compraModel' => $compraModel, // Pasar la variable a la vista
        ]);
    }

    /**
     * Creates a new Eventos model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Eventos();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'idEvento' => $model->idEvento]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Eventos model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $idEvento Id Evento
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($idEvento)
    {
        $model = $this->findModel($idEvento);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'idEvento' => $model->idEvento]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Eventos model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $idEvento Id Evento
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($idEvento)
    {
        $this->findModel($idEvento)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Eventos model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $idEvento Id Evento
     * @return Eventos the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($idEvento)
    {
        if (($model = Eventos::findOne(['idEvento' => $idEvento])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }

    /** Buscador */
    public function actionBuscar()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;

        $query = Yii::$app->request->get('query');
        $result = [];

        if ($query) {
            $result = Eventos::find()
                ->where(['like', 'nombrEvento', $query])
                ->all();
        }

        return $this->renderPartial('_resultados', ['resultados' => $result]);
    }
}

views/compras/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Compras $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="compras-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'idEvento')->textInput() ?>

    <?= $form->field($model, 'idUsuario')->textInput() ?>

    <?= $form->field($model, 'cantidad')->textInput() ?>

    <?= $form->field($model, 'fechaCompra')->textInput() ?>

    <?= $form->field($model, 'precioCompra')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'estado')->dropDownList([ 'pendiente' => 'Pendiente', 'pagado' => 'Pagado', 'cancelado' => 'Cancelado', ], ['prompt' => '']) ?>

    <?= $form->field($model, 'total')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'fechaModificacion')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/compras/cancel.php
<?php

use yii\helpers\Html;

$this->title = 'Pago Cancelado';
?>

<h1><?= Html::encode($this->title) ?></h1>

<p>El pago ha sido cancelado.</p>

views/compras/checkout-stripe.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;

?>

<h1 class="text-center titulo-busqueda-eventos"><span>Checkout</span></h1>

<?php if (Yii::$app->session->hasFlash('error')): ?>
    <div class="alert alert-danger">
        <?= Yii::$app->session->getFlash('error') ?>
    </div>
<?php endif; ?>

<!-- Tabla de entradas -->
<div class="table-responsive">
    <table class="table table-bordered table-striped table-small">
        <thead class="thead-dark">
            <tr>
                <th scope="col">Evento</th>
                <th scope="col">Precio</th>
                <th scope="col">Cantidad</th>
                <th scope="col">Total</th>
            </tr>
        </thead>
        <tbody>
            <?php foreach ($cart as $item) : ?>
                <tr>
                    <td><?= Html::encode($item['name']) ?></td>
                    <td><?= Html::encode(number_format($item['price'], 2)) ?>€</td>
                    <td><?= Html::encode($item['quantity']) ?></td>
                    <td><?= Html::encode(number_format($item['price'] * $item['quantity'], 2)) ?>€</td>
                </tr>
            <?php endforeach; ?>
        </tbody>
    </table>
</div>

<div class="form-custom mt-2">
    <form action="<?= Url::to(['compras/charge']) ?>" method="post" id="payment-form">
        <?= Html::hiddenInput(Yii::$app->request->csrfParam, Yii::$app->request->csrfToken) ?>
        
        <h2>Formulario de Pago</h2>

        <div class="form-group">
            <label for="full-name">Nombre completo</label>
            <input type="text" id="full-name" name="full-name" class="form-control" required>
        </div>

        <div class="form-group">
            <label for="billing-address">Dirección de facturación</label>
            <input type="text" id="billing-address" name="billing-address" class="form-control" required>
        </div>

        <div class="form-group">
            <label for="card-element">Tarjeta de crédito o débito</label>
            <div id="card-element">
                <!-- Stripe's Element will be inserted here. -->
            </div>
            <div id="card-errors" class="invalid-feedback" role="alert"></div>
        </div>
        
        <p>Total a pagar: <?= number_format($totalAmount / 100, 2) ?>€</p>
        <input type="hidden" name="totalAmount" value="<?= $totalAmount ?>" />

        <div class="text-center mt-3">
            <?= Html::submitButton('Pagar', ['class' => 'btn btn-primary-custom']) ?>
        </div>
    </form>
</div>

<!-- Estilos CSS para Stripe Elements y tabla pequeña -->
<style>
    #card-element {
        border: 1px solid #ced4da;
        border-radius: .25rem;
        padding: .375rem .75rem;
        margin-bottom: .5rem;
        background-color: #333;
        color: var(--white);
    }
    .form-custom {
        max-width: 500px;
        margin: 0 auto;
        padding: 15px;
        background-color: var(--bg-color);
        border-radius: var(--border-radius);
        box-shadow: 0 0 15px rgba(0, 0, 0, 0.5);
        position: relative;
        overflow: hidden;
    }
    .form-custom::before, .form-custom::after {
        content: "";
        position: absolute;
        border-radius: 50%;
        filter: blur(20px);
    }
    .form-custom::before {
        width: 100px;
        height: 100px;
        background-color: var(--violet);
        top: -50px;
        left: -50px;
        z-index: -1;
    }
    .form-custom::after {
        width: 150px;
        height: 150px;
        background-color: #00aaff;
        bottom: -75px;
        right: -75px;
        z-index: -1;
    }
    .form-custom h2 {
        color: var(--white);
        font-size: 1.5rem;
        font-weight: bold;
        margin-bottom: 15px;
    }
    .form-custom label {
        display: block;
        color: #ccc;
        font-size: 0.875rem;
        margin-bottom: 5px;
    }
    .form-custom input,
    .form-custom textarea {
        width: 100%;
        padding: 10px;
        background-color: #333;
        border: 1px solid #555;
        border-radius: var(--border-radius);
        color: var(--white);
        margin-bottom: 10px;
    }
    .form-custom input:focus,
    .form-custom textarea:focus {
        outline: none;
        border-color: var(--violet);
    }
    .form-custom button {
        background: linear-gradient(90deg, #9f5afd 0%, #9f5afd 50%, #00aaff 100%);
        color: var(--white);
        padding: 10px 20px;
        border: none;
        border-radius: var(--border-radius);
        font-weight: bold;
        cursor: pointer;
        transition: opacity 0.3s;
    }
    .form-custom button:hover {
        opacity: 0.8;
    }
    .form-custom .invalid-feedback {
        color: #e3342f;
    }
    .table-small {
        max-width: 800px;
        margin: 0 auto;
        font-size: 0.875rem;
    }
</style>

<script src="https://js.stripe.com/v3/"></script>
<script>
    var stripe = Stripe('<?= Yii::$app->params['stripe'][Yii::$app->params['stripe.env']]['publishableKey'] ?>');
    var elements = stripe.elements();
    var card = elements.create('card', {
        style: {
            base: {
                color: '#fff',
                fontFamily: '"Helvetica Neue", Helvetica, sans-serif',
                fontSmoothing: 'antialiased',
                fontSize: '16px',
                '::placeholder': {
                    color: '#aab7c4'
                }
            },
            invalid: {
                color: '#fa755a',
                iconColor: '#fa755a'
            }
        }
    });
    card.mount('#card-element');

    card.addEventListener('change', function(event) {
        var displayError = document.getElementById('card-errors');
        if (event.error) {
            displayError.textContent = event.error.message;
        } else {
            displayError.textContent = '';
        }
    });

    var form = document.getElementById('payment-form');
    form.addEventListener('submit', function(event) {
        event.preventDefault();

        stripe.createToken(card).then(function(result) {
            if (result.error) {
                var errorElement = document.getElementById('card-errors');
                errorElement.textContent = result.error.message;
            } else {
                var hiddenInput = document.createElement('input');
                hiddenInput.setAttribute('type', 'hidden');
                hiddenInput.setAttribute('name', 'stripeToken');
                hiddenInput.setAttribute('value', result.token.id);
                form.appendChild(hiddenInput);

                form.submit();
            }
        });
    });
</script>

views/compras/compra-confirmada.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;

/* @var array $cart */
/* @var string $purchaseTime */

?>
<div class="compra-confirmada">
<h1 class="text-center titulo-busqueda-eventos"><span>Compra confirmada</span></h1>
    <p class="text-center">Muchas gracias por tu compra. Aquí tienes tus entradas:</p>

    <div class="text-center">
        <?= Html::a('Ver Comprobante', ['compras/download-pdf', 'cart' => json_encode($cart), 'purchaseTime' => $purchaseTime], ['class' => 'btn btn-primary']) ?>
    </div>

    <h2 class="mt-4">Detalles de la Compra</h2>
    <p>Fecha y hora de compra: <?= Html::encode($purchaseTime) ?></p>

    <div class="table-responsive">
        <table class="table table-bordered table-striped table-small">
            <thead class="thead-dark">
                <tr>
                    <th scope="col">Evento</th>
                    <th scope="col">Precio</th>
                    <th scope="col">Cantidad</th>
                    <th scope="col">Total</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach ($cart as $item) : ?>
                    <tr>
                        <td><?= Html::encode($item['name']) ?></td>
                        <td><?= Html::encode(number_format($item['price'], 2)) ?>€</td>
                        <td><?= Html::encode($item['quantity']) ?></td>
                        <td><?= Html::encode(number_format($item['price'] * $item['quantity'], 2)) ?>€</td>
                    </tr>
                <?php endforeach; ?>
            </tbody>
        </table>
    </div>
</div>

<!-- Estilos CSS -->
<style>
    .compra-confirmada {
        max-width: 800px;
        margin: 0 auto;
        padding: 15px;
        background-color: var(--bg-color);
        border-radius: var(--border-radius);
        box-shadow: 0 0 15px rgba(0, 0, 0, 0.5);
        position: relative;
        overflow: hidden;
    }
    .compra-confirmada h1 {
        color: var(--white);
        font-size: 1.5rem;
        font-weight: bold;
        margin-bottom: 15px;
    }
    .compra-confirmada p {
        color: #ccc;
        font-size: 0.875rem;
        margin-bottom: 15px;
    }
    .compra-confirmada .btn-primary {
        background: linear-gradient(90deg, #9f5afd 0%, #9f5afd 50%, #00aaff 100%);
        color: var(--white);
        padding: 10px 20px;
        border: none;
        border-radius: var(--border-radius);
        font-weight: bold;
        cursor: pointer;
        transition: opacity 0.3s;
    }
    .compra-confirmada .btn-primary:hover {
        opacity: 0.8;
    }
    .table-small {
        max-width: 800px;
        margin: 0 auto;
        font-size: 0.875rem;
    }
    .table-responsive {
        margin-top: 20px;
    }
    .table-bordered {
        border: 1px solid #dee2e6;
    }
    .table-bordered th, .table-bordered td {
        border: 1px solid #dee2e6;
    }
    .thead-dark th {
        color: #fff;
        background-color: #343a40;
        border-color: #454d55;
    }
</style>

views/compras/create.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Compras $model */

$this->title = 'Create Compras';
$this->params['breadcrumbs'][] = ['label' => 'Compras', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="compras-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/compras/index.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;

?>
<div class="compras-index">

    <h1 class="text-center titulo-busqueda-eventos"><span>Carrito</span></h1>

    <?php if (!empty($cart)) : ?>
        <div class="table-responsive">
            <table class="table table-bordered table-striped table-fixed">
                <thead class="thead-dark">
                    <tr>
                        <th scope="col">Evento</th>
                        <th scope="col">Precio</th>
                        <th scope="col">Cantidad</th>
                        <th scope="col">Total</th>
                        <th scope="col">Acciones</th>
                    </tr>
                </thead>
                <tbody>
                    <?php foreach ($cart as $item) : ?>
                        <tr data-id="<?= $item['id'] ?>" data-price="<?= $item['price'] ?>">
                            <td><?= Html::encode($item['name']) ?></td>
                            <td><?= Html::encode(number_format($item['price'], 2)) ?>€</td>
                            <td>
                                <?= Html::input('number', 'quantity', $item['quantity'], [
                                    'min' => 1,
                                    'class' => 'form-control quantity-input',
                                    'style' => 'width: 80px; display: inline;'
                                ]) ?>
                            </td>
                            <td class="item-total"><?= Html::encode(number_format($item['price'] * $item['quantity'], 2)) ?>€</td>
                            <td>
                                <?= Html::a('Eliminar', ['compras/remove', 'id' => $item['id']], ['class' => 'btn btn-danger btn-sm']) ?>
                            </td>
                        </tr>
                    <?php endforeach; ?>
                </tbody>
            </table>
        </div>

        <div class="text-center">
            <?= Html::a('Proceder al Pago', ['compras/checkout-stripe'], ['class' => 'btn btn-primary-custom']) ?>
        </div>
    <?php else : ?>
        <div class="empty-cart-container text-center">
            <p>El carrito está vacío</p>
            <?= Html::a('Explorar Eventos', ['eventos/index'], ['class' => 'btn btn-primary-custom']) ?>
        </div>
    <?php endif; ?>

</div>

<!-- Modal de confirmación -->
<div class="modal fade" id="confirmModal" tabindex="-1" role="dialog" aria-labelledby="confirmModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="confirmModalLabel">Confirmación de Compra</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                ¿Estás a punto de comprar <span id="total-quantity"></span> entradas para el evento <span id="event-name"></span>. ¿Estás seguro?
            </div>
            <div class="modal-footer">
                <?= Html::a('Cancelar', ['eventos/index'], ['class' => 'btn btn-secondary']) ?>
                <?= Html::a('Confirmar', ['compras/confirm'], ['class' => 'btn btn-primary']) ?>
            </div>
        </div>
    </div>
</div>

<?php
$script = <<< JS
$(document).ready(function() {
    $('.quantity-input').on('change', function() {
        var quantity = $(this).val();
        var row = $(this).closest('tr');
        var id = row.data('id');
        var price = row.data('price');
        var newTotal = (quantity * price).toFixed(2);

        // Update the total price for the item
        row.find('.item-total').text(newTotal + '€');

        // Send the update to the server
        $.post('update-cart', { id: id, quantity: quantity }, function(data) {
            // Optionally handle response
        });
    });

    $('#confirmModal').on('show.bs.modal', function (event) {
        var totalQuantity = 0;
        var eventName = "";
        $('input.quantity-input').each(function() {
            totalQuantity += parseInt($(this).val());
            eventName = $(this).closest('tr').find('td:first').text();
        });
        $('#total-quantity').text(totalQuantity);
        $('#event-name').text(eventName);
    });
});
JS;
$this->registerJs($script);
?>